﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SpaceRace_del1
{
    class SpaceShip
    {
        Texture2D _gfx, _gfx_acc;
        bool _accelerating;
        float _turnRate, _rotation;
        Vector2 _position, _speed;

        #region Properties

        public Vector2 Position
        {
            get { return _position; }
            set { _position = value; }
        }

        public Vector2 Speed
        {
            get { return _speed; }
            set { _speed = value; }
        }

        public float TurnRate
        {
            get { return _turnRate; }
            set { _turnRate = value; }
        }

        public float Rotation
        {
            get { return _rotation; }
            set { _rotation = value; }
        }

        public bool Accelerating
        {
            get { return _accelerating; }
            set { _accelerating = value; }
        }

        #endregion

        public SpaceShip(Texture2D ship_normal, Texture2D ship_acc)
        {
            this._gfx = ship_normal;
            this._gfx_acc = ship_acc;
        }

        public void Update(GameTime gameTime)
        {
            _rotation += _turnRate;
            _position += _speed;
        }

        public void Draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            if (_accelerating)
                spriteBatch.Draw(_gfx_acc, _position, null, Color.White, _rotation,
                    new Vector2(_gfx.Width / 2, _gfx.Height / 2), 1.0f, SpriteEffects.None, 0);
            else
                spriteBatch.Draw(_gfx, _position, null, Color.White, _rotation,
                    new Vector2(_gfx.Width / 2, _gfx.Height / 2), 1.0f, SpriteEffects.None, 0);
        }
    }
}
